// pac.cpp

#include	"pac.h"
#include	"pacdat.h"

bool	about=FALSE;

main()
{
	pac*	app;
	app=new(pac);	app->Run();		delete app;
	return true;
}
//------------------------------------------------
pac::pac():BApplication("application/Beer/pac")
{
	pacwindow* window=new pacwindow(BRect(50,25,425,500));
}

void pac::AboutRequested()
{
	if(!about){
		about=TRUE;
		aboutwindow* window=new aboutwindow(BRect(225,25,425,175));
	}
}
//------------------------------------------------
pacwindow::pacwindow(BRect frame):BWindow(frame,"pac ver.0.021",B_TITLED_WINDOW,0)
{
	BRect	gameframe;
	gameframe.Set(0,0,375,475);				gameframe.OffsetTo(0,0);
	gview=new gameview(gameframe);			AddChild(gview);
	Show();
	SetZoomLimits(375,475);
	SetPulseRate(100000);
}

bool pacwindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}
//------------------------------------------------
gameview::gameview(BRect frame):BView(frame,"gameview",B_NOT_RESIZABLE,B_WILL_DRAW|B_PULSE_NEEDED)
{
	bmap=new BBitmap(BRect(0,0,352,400),B_RGB_32_BIT);		//map only
	bm=new BBitmap(BRect(0,0,352,400),B_RGB_32_BIT);		//all
	wait=50;	mode=0;		nextmode=-1;
	score=0;	left=3;		scene=0;
	BRect recordframe;
	recordframe.Set(0,0,274,338);			recordframe.OffsetTo(50,80);
	rview=new recordview(recordframe);		AddChild(rview);
	rview->Hide();
	hiscore=rview->hiscore;
}

void gameview::AttachedToWindow()
{
	SetViewColor(0,0,0);
	SetLowColor(120,140,170);
	SetFont(be_bold_font);	SetFontSize(20);
	MakeFocus();
}

void gameview::Draw(BRect rect)
{
	SetHighColor(222,255,255);SetLowColor(111,128,128);
	DrawString("1UP"		,BPoint(5,20));
	DrawString("TOP"		,BPoint(150,20));
	DrawString("Left"		,BPoint(5,470));
	DrawString("Stage"		,BPoint(280,470));
	SetHighColor(255,222,222);SetLowColor(128,111,111);
	DrawString("PAC"		,BPoint(300,20));
	DrawString("ver.0.02"	,BPoint(300,40));
	if(mode<=0){
		SetHighColor(255,255,222);SetLowColor(128,128,111);
		DrawString("PAC"										,BPoint(50,150));
		DrawString("Start ... hit any key   or   click mouse"	,BPoint(30,250));
		DrawString("Move  ... ten-key  or  cursor-key"			,BPoint(30,280));
	}
	if(mode>0)drawgame(-1);
	drawscore(-1);
}

void gameview::Pulse()
{
	if(!rview->IsHidden()){rview->pulse();return;}
	if(wait>0){
		if(--wait>0)return;
		if(nextmode==1)*mes=0;
	}
	if(mode!=nextmode){
		bool f=((mode>0)&&(nextmode==0));
		mode=nextmode;
		switch(mode){
			case -1:						//ranking
				rview->show(100);
				nextmode=0;
				break;
			case 0:							//title
				wait=150;	nextmode=-1;
				left=3;		scene=0;
				break;
			case 1:							//game
				initgame();
				break;
			case 2:							//record
				rview->setrecord(score);
				wait=20;	nextmode=0;
				break;
		}
		if(f)Invalidate();
		return;
	}
	if(mode==1){
		if(dots>0){
			if(pman.dead){
				if(pman.dead++>15){
					if(--left<0)gameover();else contgame();
				}
				if((pman.dead>2)&&(pman.dead<13))pman.df=2;
				if(pman.dead==13){pman.xold=pman.x;pman.yold=pman.y;pman.df=1;}
				if((pman.dead>2)&&(pman.dead<5))for(int i=0;i<4;i++)mons[i].df=2;
				if(pman.dead==5)for(int i=0;i<4;i++){mons[i].xold=mons[i].x;mons[i].yold=mons[i].y;mons[i].df=1;}
			}else{
				movemon();
				movepac();
			}
		}else{
			clearstage();
		}
		drawchrs();
		drawgame(-1);
	}
}

void gameview::KeyDown(const char *bytes,int32 numBytes)
{
	if(!rview->IsHidden())return;
	if(mode<=0){nextmode=1;wait=0;}
	kin=0;
	if(numBytes==1){
		if((*bytes=='8')||(*bytes==B_UP_ARROW))kin=1;		//up
		if((*bytes=='2')||(*bytes==B_DOWN_ARROW))kin=2;	//down
		if((*bytes=='4')||(*bytes==B_LEFT_ARROW))kin=4;	//left
		if((*bytes=='6')||(*bytes==B_RIGHT_ARROW))kin=8;	//right
	}
}

void gameview::MouseDown(BPoint pt)
{
	if(!rview->IsHidden())return;
	if((pt.x>300)&&(pt.y<50))be_app->PostMessage(B_ABOUT_REQUESTED);
	else if(mode<=0){nextmode=1;wait=0;}
}

void gameview::movepac()
{
	int		x,y,dd;
	int		u,d,l,r;
	char	f;
	chkspc(pman.x,pman.y,&u,&d,&l,&r,&f);
	if(pman.df==0){
		if(kin&f)dd=kin;
		else if(pman.d&f)dd=pman.d;
		else dd=0;
		if(dd!=0){				//move
			pman.xold=pman.x;
			pman.yold=pman.y;
			pman.d=dd;
			if(dd==1)pman.y-=8;
			if(dd==2)pman.y+=8;
			if(dd==4)pman.x=(pman.x>18)?pman.x-8:290;
			if(dd==8)pman.x=(pman.x<290)?pman.x+8:18;
			anip=(anip+1)%6;
			pman.df=3;
		}else{
			pman.df=2;
		}
		x=(pman.x+6)/16;	y=(pman.y+6)/16;
		if((map[y][x]=='.')||(map[y][x]=='o')){
			int		dy=bmap->BytesPerRow()/4;
			uint32	*p=(uint32*)(bmap->Bits())+dy*(y*16)+(x*16);
			if(map[y][x]=='.')score+=10;
			if(map[y][x]=='o'){
				for(int i=0;i<4;i++)if(mons[i].mf>1)mons[i].it=75-((scene-1)%5)*15;
				ren=0;
				score+=50;
			}
			drawscore(1);
			map[y][x]=' ';
			for(int i=0;i<16;i++)for(int j=0;j<16;j++)*(p+dy*i+j)=0;
			dots--;
		}
		for(int i=0;i<4;i++){
			if((abs(pman.x-mons[i].x)<=8)&&(abs(pman.y-mons[i].y)<=8)){
				if(mons[i].it>0){
					mons[i].it=0;
					mons[i].mf=1;
					mons[i].pf=4;
					score+=200*(1<<ren++);
					drawscore(1);
					wait=5;
				}else if(mons[i].mf>1){
					pman.dead=1;
					break;
				}
			}
		}
	}
}

void gameview::movemon()
{
	int		u,d,l,r;
	char	f;
	int		sp;		//move speed
	char	dd[4],ddn;
	int		dx,dy,df;
	for(int m=0;m<4;m++){
		mons[m].xold=mons[m].x;	
		mons[m].yold=mons[m].y;
		if(mons[m].it>0){
			mons[m].it--;
			if(mons[m].it>0){
				mons[m].pf=(mons[m].it>35)?2:3;
				if((mons[m].mf==4)||(mons[m].mf==5))mons[m].mf=6;
			}else{
				mons[m].pf=1;
				if(mons[m].mf==6)mons[m].mf=4;
			}
		}
		switch(mons[m].mf){
			case 1:
				mons[m].speed=16;
				if((abs(mons[m].x-154)<=8)&&(abs(mons[m].y-138)<=8)){
					if(m==0){
						mons[m].x=10*16-6;
						mons[m].y=11*16-6;
						mons[m].d=2;
					}else{
						mons[m].x=(m+8)*16-6;
						mons[m].y=12*16-6;
						mons[m].d=1;
					}
					mons[m].t=0;
					mons[m].mf=2;
					mons[m].pf=1;
				}
				break;
			case 2:
				if(mons[m].t--<0)mons[m].mf=3;
				chkspc(mons[m].x,mons[m].y,&u,&d,&l,&r,&f);
				if(!(mons[m].d&f))mons[m].d=f&3;	//up or down only
				mons[m].speed=4;
				break;
			case 3:
				if(mons[m].x==154){
					mons[m].d=1;
					mons[m].speed=(mons[m].y<170)?2:8;
					if(mons[m].y<142){
						mons[m].mf=4;
						mons[m].t=50;
					}
				}else{
					mons[m].d=(mons[m].x<154)?8:4;	//go center
					mons[m].speed=4;
				}
				break;
			case 4:
			case 5:
				if(mons[m].t--<0){
					mons[m].mf=(mons[m].mf==4)?5:4;
					mons[m].t=50;
					mons[m].d=(mons[m].d&5)?mons[m].d*2:mons[m].d/2;	//back
				}
				if(m==0)mons[m].speed=9;
				if(m==1)mons[m].speed=8;
				if(m==2)mons[m].speed=7;
				if(m==3)mons[m].speed=7;
				break;
			case 6:
				mons[m].speed=6;
				break;
		}
		sp=((mons[m].y==186)&&((mons[m].x<42)||(mons[m].x>266)))?4:mons[m].speed;	//slow in warp
		gonextblock(&(mons[m].x),&(mons[m].y),mons[m].d,&sp);
		if(sp>0){
			chkspc(mons[m].x,mons[m].y,&u,&d,&l,&r,&f);
			if(mons[m].mf>1){
				dx=pman.x-mons[m].x;	dy=pman.y-mons[m].y;
			}else{
				dx=154-mons[m].x;		dy=138-mons[m].y;
			}
			switch(mons[m].mf){
				case 4:
					ddn=0;
					if(mons[m].d!=2)dd[ddn++]=1;
					if(mons[m].d!=1)dd[ddn++]=2;
					if(mons[m].d!=8)dd[ddn++]=4;
					if(mons[m].d!=4)dd[ddn++]=8;
					swap(&(dd[random()%3]),&(dd[random()%3]));
					for(ddn=0;ddn<3;ddn++)if(dd[ddn]&f){mons[m].d=dd[ddn];	break;}
					break;
				case 1:
				case 5:
				case 6:
					ddn=0;
					df=0;
					if((m==0)||(mons[m].mf==1)){
						if(abs(dx)<abs(dy))df|=1;
						if(dy>0)df|=2;
						if(dx>0)df|=4;
					}else if(m==1){
						if((abs(dx)>abs(dy))&&(dy!=0)||(dx==0))df|=1;
						if(dy>0)df|=2;
						if(dx>0)df|=4;
					}else if(m==2){
						if(dx==0){
							if(dy<0)df|=2;
						}else{
							if(abs(dx)<abs(dy))df|=1;
							if(dy>0)df|=2;
							if(dx>0)df|=4;
						}
					}else if(m==3){
						if(dy==0){
							df|=1;
							if(dx<0)df|=4;
						}else{
							if((abs(dx)>abs(dy))&&(dy!=0)||(dx==0))df|=1;
							if(dy>0)df|=2;
							if(dx>0)df|=4;
						}
					}
					switch(df){
						case 0:
							if(mons[m].d!=8)dd[ddn++]=4;
							if(mons[m].d!=2)dd[ddn++]=1;
							if(mons[m].d!=1)dd[ddn++]=2;
							if(mons[m].d!=4)dd[ddn++]=8;
							break;
						case 1:
							if(mons[m].d!=2)dd[ddn++]=1;
							if(mons[m].d!=8)dd[ddn++]=4;
							if(mons[m].d!=4)dd[ddn++]=8;
							if(mons[m].d!=1)dd[ddn++]=2;
							break;
						case 2:
							if(mons[m].d!=8)dd[ddn++]=4;
							if(mons[m].d!=1)dd[ddn++]=2;
							if(mons[m].d!=2)dd[ddn++]=1;
							if(mons[m].d!=4)dd[ddn++]=8;
							break;
						case 3:
							if(mons[m].d!=1)dd[ddn++]=2;
							if(mons[m].d!=8)dd[ddn++]=4;
							if(mons[m].d!=4)dd[ddn++]=8;
							if(mons[m].d!=2)dd[ddn++]=1;
							break;
						case 4:
							if(mons[m].d!=4)dd[ddn++]=8;
							if(mons[m].d!=2)dd[ddn++]=1;
							if(mons[m].d!=1)dd[ddn++]=2;
							if(mons[m].d!=8)dd[ddn++]=4;
							break;
						case 5:
							if(mons[m].d!=2)dd[ddn++]=1;
							if(mons[m].d!=4)dd[ddn++]=8;
							if(mons[m].d!=8)dd[ddn++]=4;
							if(mons[m].d!=1)dd[ddn++]=2;
							break;
						case 6:
							if(mons[m].d!=4)dd[ddn++]=8;
							if(mons[m].d!=1)dd[ddn++]=2;
							if(mons[m].d!=2)dd[ddn++]=1;
							if(mons[m].d!=8)dd[ddn++]=4;
							break;
						case 7:
							if(mons[m].d!=1)dd[ddn++]=2;
							if(mons[m].d!=4)dd[ddn++]=8;
							if(mons[m].d!=8)dd[ddn++]=4;
							if(mons[m].d!=2)dd[ddn++]=1;
							break;
					}
					if(mons[m].mf==6)swap(&(dd[0]),&(dd[2]));
					for(ddn=0;ddn<3;ddn++){
						if(dd[ddn]&f){
							if(mons[m].d!=dd[ddn]){		//speed down at curve
								if(sp<=2){sp=0;break;}
								sp-=2;
							}
							mons[m].d=dd[ddn];break;
						}
					}
					break;
			}
			if(mons[m].d==1)mons[m].y-=sp;
			if(mons[m].d==2)mons[m].y+=sp;
			if(mons[m].d==4){
				mons[m].x-=sp;
				if(mons[m].x<11)mons[m].x=290;
			}
			if(mons[m].d==8){
				mons[m].x+=sp;
				if(mons[m].x>297)mons[m].x=18;
			}
		}
		mons[m].df=3;				//move(erase&draw)
	}
}

void gameview::gonextblock(int *x,int *y,char d,int *steps)
{
	int	g;
	switch(d){
		case 1:
			g=((*y)+6)%16;
			if(g>*steps)g=*steps;
			(*y)-=g;
			break;
		case 2:
			g=((*y)+6)%16;
			if(g>0)g=16-g;
			if(g>*steps)g=*steps;
			(*y)+=g;
			break;
		case 4:
			g=((*x)+6)%16;
			if(g>*steps)g=*steps;
			(*x)-=g;
			break;
		case 8:
			g=((*x)+6)%16;
			if(g>0)g=16-g;
			if(g>*steps)g=*steps;
			(*x)+=g;
			break;
	}
	(*steps)-=g;
}

void gameview::chkspc(int x,int y,int *u,int *d,int *l,int *r,char *f)
{
	*u=*d=*l=*r=0;
	for(int i=1;i<17;i++)if((map[(y+6-i)/16][(x+6)/16]!='*')&&(map[(y+6-i)/16][(x+21)/16]!='*'))(*u)++;else break;
	for(int i=1;i<17;i++)if((map[(y+21+i)/16][(x+6)/16]!='*')&&(map[(y+21+i)/16][(x+21)/16]!='*'))(*d)++;else break;
	for(int i=1;i<17;i++)if((map[(y+6)/16][(x+6-i)/16]!='*')&&(map[(y+21)/16][(x+6-i)/16]!='*'))(*l)++;else break;
	for(int i=1;i<17;i++)if((map[(y+6)/16][(x+21+i)/16]!='*')&&(map[(y+21)/16][(x+21+i)/16]!='*'))(*r)++;else break;
	*f=((*u>0)?1:0)|((*d>0)?2:0)|((*l>0)?4:0)|((*r>0)?8:0);
}

void gameview::drawscore(char f)
{
	char	s[16];
	SetHighColor(0,0,0);	
	if(f&1)FillRect(BRect(0,22,100,45));
	if(f&2)FillRect(BRect(150,22,250,45));
	if(f&4)FillRect(BRect(50,452,100,470));
	if(f&8)FillRect(BRect(350,452,400,470));
	SetHighColor(255,255,255);SetLowColor(128,128,128);
	if(f&1){sprintf(s,"%06d",score);	DrawString(s,BPoint(5,45));}
	if(f&2){sprintf(s,"%06d",hiscore);	DrawString(s,BPoint(150,45));}
	if(f&4){sprintf(s,"%d",left);		DrawString(s,BPoint(50,470));}
	if(f&8){sprintf(s,"%d",scene);		DrawString(s,BPoint(350,470));}
}

void gameview::drawgame(char flag)
{
	if(flag==-1){		//all
		DrawBitmap(bm,BPoint(20,50));
		if(*mes){
			SetHighColor(mes_col>>8,mes_col>>16,mes_col>>24);
			DrawString(mes,BPoint((80-StringWidth(mes))/2+148,290));
		}
	}
}

void gameview::clearstage()
{
	if(dots<-5){
		initscene();
		contgame();
	}else{
		if(dots==0){
			pman.df=2;
			for(int i=0;i<4;i++){
				mons[i].xold=mons[i].x;
				mons[i].yold=mons[i].y;
				mons[i].df=1;
			}
		}
		int		l=bmap->BitsLength()/4;
		uint32	*p=(uint32*)(bmap->Bits());
		uint32	*q=(uint32*)(bm->Bits());
		for(int i=0;i<l;i++){
			if(*p>0)*q=(dots&1)?ww_col:wb_col;
			p++;q++;
		}
		wait=5;
		dots--;
	}
}

void gameview::gameover()
{
	if(score>hiscore){hiscore=score;drawscore(-1);}
	strcpy(mes,"GAME OVER");	mes_col=0x0000ff00;
	wait=30;
	nextmode=2;
}

void gameview::initgame()
{
	score=0;	left--;
	initscene();
	contgame();
}

void gameview::initscene()
{
	uint32	*p;
	int		dy=bmap->BytesPerRow()/4;
	scene++;
// set_work map
	for(int y=0;y<25;y++)for(int x=0;x<21;x++)map[y][x]=def_map[y][x];
// draw_back map
	memset(bmap->Bits(),0,bmap->BitsLength());
	dots=0;
	for(int y=1;y<24;y++)for(int x=1;x<20;x++){
		p=(uint32*)(bmap->Bits())+dy*(y*16)+(x*16);
		if(map[y][x]=='*'){
			char z=0;
			if(map[y-1][x]=='*')z|=1;	//north
			if(map[y+1][x]=='*')z|=2;	//south
			if(map[y][x+1]=='*')z|=4;	//east
			if(map[y][x-1]=='*')z|=8;	//west
			pic16(p,dy,wall[z],wb_col);
		}
		if(map[y][x]=='.'){
			pic16(p,dy,dot,d_col);
			dots++;
		}
		if(map[y][x]=='o'){
			pic16(p,dy,pdot,p_col);
			dots++;
		}
	}
}

void gameview::contgame()
{
	pman.dead=0;
// copy bmap to bm
	bcopy(bmap->Bits(),bm->Bits(),bmap->BitsLength());
// set_pos pac&monst
	pman.x=10*16-6;		pman.y=18*16-6;		pman.d=4;		pman.df=2;
	mons[0].x=10*16-6;	mons[0].y=11*16-6;	mons[0].d=2;
	mons[0].t=10;
	mons[1].x=10*16-6;	mons[1].y=12*16-6;	mons[1].d=2;
	mons[1].t=(scene<3)?50:30;
	mons[2].x=9*16-6;	mons[2].y=12*16-6;	mons[2].d=2;
	mons[2].t=(scene<5)?70:50;
	mons[3].x=11*16-6;	mons[3].y=12*16-6;	mons[3].d=1;
	mons[3].t=(scene<5)?100:70;
	for(int i=0;i<4;i++){mons[i].df=2;mons[i].mf=2;mons[i].it=0;mons[i].pf=1;}
	anip=1;	anim=0;
	strcpy(mes,"READY !");	mes_col=0x00ffff00;	wait=10;
	drawchrs();				// draw_back pac&monst
	drawscore(-1);			// draw_score
	drawgame(-1);			// draw_pic from back
	kin=0;
}

void gameview::drawchrs()
{
	uint32	*p;
	int		dy=bm->BytesPerRow()/4;
	if(pman.df&1)copybm(bmap,bm,pman.xold,pman.yold,28,28);
	if(pman.df&2)copybm(bmap,bm,pman.x,pman.y,28,28);
	for(int i=0;i<4;i++)if(mons[i].df&1)copybm(bmap,bm,mons[i].xold,mons[i].yold,28,28);
	for(int i=3;i>=0;i--)if((mons[i].df&2)&&(mons[i].pf>1)){
		p=(uint32*)(bm->Bits())+dy*mons[i].y+mons[i].x;
		if((mons[i].pf==2)||(mons[i].pf==3)){
			int f=((mons[i].pf==3)&&(anim&4))?6:4;
			pic28(p,dy,mon_pat[anim&1],mon_col[f]);
			pic28(p,dy,mon_pat[2],mon_col[f+1]);
		}
		if(mons[i].pf==4){
			int e=0;if(mons[i].d==2)e=2;if(mons[i].d==4)e=4;if(mons[i].d==8)e=6;
			pic28(p,dy,eye_pat[e],eyew_col);
			pic28(p,dy,eye_pat[e+1],eyeb_col);
		}
	}
	if(pman.df&2){
		p=(uint32*)(bm->Bits())+dy*pman.y+pman.x;
		int a=0;
		if(pman.dead>6){	//dying
			a=(pman.dead<10)?10-pman.dead:3+pman.dead;
		}else{
			if(anip!=3){
				a=1;if(pman.d==2)a=4;if(pman.d==4)a=7;if(pman.d==8)a=10;
				a+=(anip<4)?anip:6-anip;
			}
		}
		pic28(p,dy,pac_pat[a],pac_col);
	}
	for(int i=3;i>=0;i--)if((mons[i].df&2)&&(mons[i].pf==1)){
		p=(uint32*)(bm->Bits())+dy*mons[i].y+mons[i].x;
		pic28(p,dy,mon_pat[anim&1],mon_col[i]);
		int e=0;if(mons[i].d==2)e=2;if(mons[i].d==4)e=4;if(mons[i].d==8)e=6;
		pic28(p,dy,eye_pat[e],eyew_col);
		pic28(p,dy,eye_pat[e+1],eyeb_col);
	}
	pman.df=0;
	for(int i=0;i<4;i++)mons[i].df=0;
	anim=(anim+1)&7;
}

void gameview::copybm(BBitmap *s,BBitmap *d,int x,int y,int w,int h)
{
	int		dy=bm->BytesPerRow();
	for(int i=y;i<y+h;i++){
		bcopy((char*)(s->Bits())+dy*i+x*4,(char*)(d->Bits())+dy*i+x*4,w*4);
	}
}

void gameview::pic16(uint32 *p,int dy,cgpat16 cgp,int32 col)
{
	uint16 k,*q=(uint16*)(cgp.pat);
	for(int i=0;i<16;i++){
		k=0x8000;
		for(int j=0;j<16;j++){
			if((*q)&k)*(p+dy*i+j)=col;
			k>>=1;
		}
		q++;
	}
}

void gameview::pic28(uint32 *p,int dy,cgpat28 cgp,int32 col)
{
	uint32 k,*q=(uint32*)(cgp.pat);
	for(int i=0;i<28;i++){
		k=0x80000000;
		for(int j=0;j<28;j++){
			if((*q)&k)*(p+dy*i+j)=col;
			k>>=1;
		}
		q++;
	}
}

void gameview::swap(char *a,char *b)
{
	char	d;
	d=*a;	*a=*b;	*b=d;
}
//------------------------------------------------
recordview::recordview(BRect frame):BView(frame,"recordview",B_NOT_RESIZABLE,B_WILL_DRAW)
{
	readrecord();
	waiting=false;
	hiscore=rec[0].score;
}

void recordview::AttachedToWindow()
{
	SetViewColor(50,150,100);
	SetFont(be_bold_font);
	SetFontSize(20);
}

void recordview::Draw(BRect rect)
{
	char	s[16];
	SetHighColor(255,255,255);SetLowColor(128,128,128);
	DrawString("Ranking",BPoint(20,25));
	for(int i=0;i<10;i++){
		if(i==you)continue;
		sprintf(s,"%d",i+1);			DrawString(s,BPoint(20-StringWidth(s)/2,55+i*30));
		sprintf(s,"%d",rec[i].score);	DrawString(s,BPoint(120-StringWidth(s),55+i*30));
										DrawString(rec[i].name,BPoint(140,55+i*30));
	}
	drawyou();
}

void recordview::KeyDown(const char *bytes,int32 numBytes){
	if(you<0)hide();
	if(!waiting)return;
	if(numBytes==1){
		int l=strlen(rec[you].name);
		if((*bytes>=0x20)&&(*bytes<0x7f)){rec[you].name[l++]=*bytes;rec[you].name[l]=0;}
		if((*bytes==B_BACKSPACE)&&(l>0))rec[you].name[l-1]=0;
		if(*bytes==B_ENTER){for(int i=l;i<15;i++)rec[you].name[i]=' ';rec[you].name[15]=0;}
		if(strlen(rec[you].name)==15){waiting=false;writerecord();}
	}
}

void recordview::MouseDown(BPoint pt)
{
	if(you<0)hide();
}

void recordview::pulse()
{
	if(you>=0)drawyou();
	if(!waiting)if(--wait<0)hide();
}

void recordview::drawyou()
{
	if(you<0)return;
	char	s[16];
	int		r=random()%256;
	SetHighColor(50,150,100);			FillRect(BRect(130,30+you*30,280,60+you*30));
	SetHighColor(255,0,0);SetLowColor(128,50,0);
	sprintf(s,"%d",you+1);				DrawString(s,BPoint(20-StringWidth(s)/2,55+you*30));
	sprintf(s,"%d",rec[you].score);	DrawString(s,BPoint(120-StringWidth(s),55+you*30));
										DrawString(rec[you].name,BPoint(140,55+you*30));
	if(waiting){
		SetHighColor(255,r,r);
		DrawChar('_',BPoint(140+StringWidth(rec[you].name),55+you*30));
	}
}

void recordview::readrecord()
{
	BFile		*rf;
	rf=new BFile("/boot/home/config/settings/Beer/pac.dat",O_RDONLY);
	if(rf->IsReadable()){
		char buf[256],*p=buf,*q;
		rf->Read(buf,256);
		for(int i=0;i<10;i++){
			while(*p<'0')while(*(p++)!='\n');
			sscanf(p,"%d",&(rec[i].score));
			while(*(p++)!=' ');
			q=rec[i].name;
			while(*p!='\n')*(q++)=*(p++);
		}
	}else{
		for(int i=0;i<10;i++){rec[i].score=10000-i*1000;strcpy(rec[i].name,"Beer");}
	}
	delete rf;
}

void recordview::writerecord()
{
	BDirectory	*rd;
	BFile		*rf;
	rd=new BDirectory("/boot/home/config/settings");
	rd->CreateDirectory("Beer",rd);
	rf=new BFile("/boot/home/config/settings/Beer/pac.dat",O_WRONLY|O_CREAT);
	if(rf->IsWritable()){
		char buf[256],*p=buf;
		p+=sprintf(p,"!pac ver.0.02  <Beer-hirotsu>\n");
		for(int i=0;i<10;i++)p+=sprintf(p,"%d %s\n",rec[i].score,rec[i].name);
		rf->Write(buf,p-buf);
	}
	delete rf;delete rd;
}

int recordview::setrecord(int score)
{
	wait=50;
	you=-1;
	for(int i=9;i>=0;i--)if(score>rec[i].score)you=i;
	if(score>hiscore)hiscore=score;
	if(you>=0){
		for(int i=9;i>you;i--){
			rec[i].score=rec[i-1].score;
			strcpy(rec[i].name,rec[i-1].name);
		}
		rec[you].score=score;
		strcpy(rec[you].name,"");
		waiting=true;
	}else{
		waiting=false;
	}
	Show();
	MakeFocus();
	return(you);
}

void recordview::show(int w)
{
	wait=w;
	you=-1;
	Show();
	MakeFocus();
}

void recordview::hide()
{
	Hide();
	Parent()->MakeFocus();
	waiting=false;
}
//------------------------------------------------
aboutwindow::aboutwindow(BRect frame):BWindow(frame,"about (pac)",B_TITLED_WINDOW,B_NOT_RESIZABLE)
{
	BRect	aframe;
	aframe.Set(0,0,200,150);		aframe.OffsetTo(0,0);
	aview=new aboutview(aframe);	AddChild(aview);
	Show();
	SetZoomLimits(200,150);
}

bool aboutwindow::QuitRequested()
{
	about=FALSE;
	return true;
}
//------------------------------------------------
aboutview::aboutview(BRect frame):BView(frame,"aboutview",B_NOT_RESIZABLE,B_WILL_DRAW)
{
}

void aboutview::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(222,255,222);
	SetLowColor(222,255,222);
	SetFont(be_plain_font);
}

void aboutview::Draw(BRect rect)
{
	SetFontSize(18);
	DrawString("PAC  ver.0.021"						,BPoint(30,30));
	SetFontSize(12);
	DrawString("1998. 5.29"							,BPoint(100,60));
	DrawString("by Hiroyuki Tsutsumi"				,BPoint(50,100));
	DrawString("hirotsu@blue.plala.or.jp"			,BPoint(15,120));
	DrawString("http://www1.plala.or.jp/hirotsu/"	,BPoint(15,140));
}
