// pac.h

#include	<Be.h>

struct cgpat16{
	uint16	pat[16];
};

struct cgpat28{
	uint32	pat[28];
};

class monstar
{
	public:
		int		x,y;			//position
		int		xold,yold;		//old position
		char	d;				//direction 1.up 2.down 4.left 8.right
		int		speed;			//speed
		int		t;				//timer
		char	mf;				//1.back(eye) 2.wait(in house) 3.go
								//4.walk 5.chase 6.escape
		int		it;				//izike timer
		char	pf;				//pic flag 1..normal 2..blue 3..flush 4..eye 
		char	df;				//draw flag b0..erase b1..draw
};

class pacman
{
	public:
		int		x,y;			//position
		int		xold,yold;		//old position
		char	d;				//direction 1.up 2.down 4.left 8.right
		char	df;				//draw flag b0..erase b1..draw
		char	dead;
};

class pac:public BApplication
{
	public:
		pac();
		void	AboutRequested();
};

class recordview:public BView
{
		typedef struct{
			int		score;
			char	name[16];
		}record;
	public:
		recordview(BRect frame);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	KeyDown(const char *bytes,int32 numBytes);
		void	MouseDown(BPoint pt);
		void	pulse();
		void	drawyou();
		void	readrecord();
		void	writerecord();
		int		setrecord(int score);	//return ranking
		void	show(int w);
		void	hide();
		bool	waiting;
		int		hiscore;
	private:
		record	rec[10];
		int		wait,you;
};

class gameview:public BView
{
	public:
		gameview(BRect frame);
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	Pulse();
		void	KeyDown(const char *bytes,int32 numBytes);
		void	MouseDown(BPoint pt);
		void	movepac();
		void	movemon();
		void	gonextblock(int *x,int *y,char d,int *steps);
		void	chkspc(int x,int y,int *u,int *d,int *l,int *r,char *f);
		void	drawscore(char f);
		void	drawgame(char flag);
		void	clearstage();
		void	gameover();
		void	initgame();
		void	initscene();
		void	contgame();
		void	drawchrs();
		void	copybm(BBitmap *s,BBitmap *d,int x,int y,int w,int h);
		void	pic16(uint32 *p,int dy,cgpat16 cgp,int32 col);
		void	pic28(uint32 *p,int dy,cgpat28 cgp,int32 col);
		void	swap(char *a,char *b);
	private:
		BBitmap	*bm,*bmap;
		char	map[25][22];
		monstar	mons[4];
		pacman	pman;
		int		hiscore,score,left,scene,dots;
		int		mode,nextmode,wait;
		int		anip,anim;
		int		ren;	//renzoku get
		char	kin;	//last keyin b0.up b1.down b2.left b3.right
		char	mes[16];
		uint32	mes_col;
		recordview	*rview;
};

class pacwindow:public BWindow
{
	public:
		pacwindow(BRect frame);
		bool	QuitRequested();
	private:
		gameview	*gview;
};

class aboutview:public BView
{
	public:
		aboutview(BRect frame);
		void	AttachedToWindow();
		void	Draw(BRect rect);
};

class aboutwindow:public BWindow
{
	public:
		aboutwindow(BRect frame);
		bool	QuitRequested();
	private:
		aboutview	*aview;
};
